% Copiright (c) 2016 - A. Panichella

function [auc, graph]=optimal_curve(test_oracle, test_metrics)

data = [test_oracle, test_metrics(:,7), test_oracle./test_metrics(:,7)];
data = sortrows(data,-3);

m=length(test_oracle);
sensitivity = zeros(1,m); 
cost = zeros(1,m);
cumulative_bug = 0;
cumulative_cost=0;
for i=1:m
   cumulative_bug = cumulative_bug + data(i,1);
   sensitivity(i) = cumulative_bug; 
   cumulative_cost = cumulative_cost + data(i,2);
   cost(i) = cumulative_cost;
end
graph.x = cost/max(cost);
graph.y = sensitivity/max(sensitivity);
auc = trapz(graph.x, graph.y);
end